// generated with ast extension for cup
// version 0.8
// 16/10/2017 11:59:43


package ppdz.ast;

public class Program implements SyntaxNode {

    private SyntaxNode parent;
    private int line;
    private Prog_id prog_id;
    private Declaration_list declaration_list;
    private Method_declaration_list method_declaration_list;

    public Program (Prog_id prog_id, Declaration_list declaration_list, Method_declaration_list method_declaration_list) {
        this.prog_id=prog_id;
        if(prog_id!=null) prog_id.setParent(this);
        this.declaration_list=declaration_list;
        if(declaration_list!=null) declaration_list.setParent(this);
        this.method_declaration_list=method_declaration_list;
        if(method_declaration_list!=null) method_declaration_list.setParent(this);
    }

    public Prog_id getProg_id() {
        return prog_id;
    }

    public void setProg_id(Prog_id prog_id) {
        this.prog_id=prog_id;
    }

    public Declaration_list getDeclaration_list() {
        return declaration_list;
    }

    public void setDeclaration_list(Declaration_list declaration_list) {
        this.declaration_list=declaration_list;
    }

    public Method_declaration_list getMethod_declaration_list() {
        return method_declaration_list;
    }

    public void setMethod_declaration_list(Method_declaration_list method_declaration_list) {
        this.method_declaration_list=method_declaration_list;
    }

    public SyntaxNode getParent() {
        return parent;
    }

    public void setParent(SyntaxNode parent) {
        this.parent=parent;
    }

    public int getLine() {
        return line;
    }

    public void setLine(int line) {
        this.line=line;
    }

    public void accept(Visitor visitor) {
        visitor.visit(this);
    }

    public void childrenAccept(Visitor visitor) {
        if(prog_id!=null) prog_id.accept(visitor);
        if(declaration_list!=null) declaration_list.accept(visitor);
        if(method_declaration_list!=null) method_declaration_list.accept(visitor);
    }

    public void traverseTopDown(Visitor visitor) {
        accept(visitor);
        if(prog_id!=null) prog_id.traverseTopDown(visitor);
        if(declaration_list!=null) declaration_list.traverseTopDown(visitor);
        if(method_declaration_list!=null) method_declaration_list.traverseTopDown(visitor);
    }

    public void traverseBottomUp(Visitor visitor) {
        if(prog_id!=null) prog_id.traverseBottomUp(visitor);
        if(declaration_list!=null) declaration_list.traverseBottomUp(visitor);
        if(method_declaration_list!=null) method_declaration_list.traverseBottomUp(visitor);
        accept(visitor);
    }

    public String toString(String tab) {
        StringBuffer buffer=new StringBuffer();
        buffer.append(tab);
        buffer.append("Program(\n");

        if(prog_id!=null)
            buffer.append(prog_id.toString("  "+tab));
        else
            buffer.append(tab+"  null");
        buffer.append("\n");

        if(declaration_list!=null)
            buffer.append(declaration_list.toString("  "+tab));
        else
            buffer.append(tab+"  null");
        buffer.append("\n");

        if(method_declaration_list!=null)
            buffer.append(method_declaration_list.toString("  "+tab));
        else
            buffer.append(tab+"  null");
        buffer.append("\n");

        buffer.append(tab);
        buffer.append(") [Program]");
        return buffer.toString();
    }
}
